﻿@page "/customer/edit/{id:guid}"

<h3>Edit customer</h3>

<p>
    <a href="/customer">
        Return to index
    </a>
</p>

<CustomerCreateEditForm @bind-Form="Form" OnSubmit="OnSubmit"></CustomerCreateEditForm>

@code {
    [Inject]
    public IDbContextFactory<ShopDbContext> DbFactory { set; get; }

    [Parameter]
    public Guid ID { set; get; }

    public CustomerCreateEditFormModel Form { set; get; } = new CustomerCreateEditFormModel();

    async Task OnSubmit(CustomerCreateEditFormModel form)
    {
        using var db = DbFactory.CreateDbContext();
        var customer = await db.Customers.Where(Q => Q.CustomerID == ID).FirstOrDefaultAsync();
        customer.Name = form.Name;
        customer.Email = form.Email;
        await db.SaveChangesAsync();
    }

    protected override async Task OnInitializedAsync()
    {
        using var db = DbFactory.CreateDbContext();
        var customer = await db.Customers.AsNoTracking().Where(Q => Q.CustomerID == ID).FirstOrDefaultAsync();
        Form.Name = customer.Name;
        Form.Email = customer.Email;
    }
}
